# README #

This README would normally document whatever steps are necessary to get your application up and running.

### Для чего этот репозиторий ###

* Этот репозиторий содержит материалы моей разработки программы для [радиомодуля
  Михаила Тихончука](http://electromost.com/news/raspberry_pi_dlja_domashnej_avtomatizacii_radiomodul/2014-08-22-125)
  для него разработана Антоном Бизяевым [печатная плата](https://easyeda.com/electromost/_v1_1-05c0456e964846ae912ad4c3079c1dfc)
* Версия прошивки 2.0
* [Материалы репозитория](https://bitbucket.org/AlexAW/radiomodul)

### Что можно сделать с проектом? ###

* Проект содержит модель радиомодуля в PROTEUS которая позволяет симулировать прием радиосигнала разных форм
  Посматривать и отлаживать работу программы в реальном времени.
* В качестве источников сигнала используется симулятор сигналов произвольной формы 
	симулируются подобие шума, кодовую последовательность, преамбулу

### Сведения об изменениях ###

23.12.2017
		Написан и отлажен модуль управления режимами работы устройства
	Переход в режим программирования осуществляется долгим (5 сек.) удержанием первой кнопки
	произойдет индикация перехода в режим программирования и отобразится номер готовой к записи ячейки.
	Всего ячеек 31 Номер отображается светодиодами в двоичном коде от 1 до 31.
	
		В режиме программирования выбор номера записываемой ячейки осуществляется кратковременным нажатием первой кнопки.
	При удержании этой кнопки более 1 сек. происходит автоинкремент номера программируемой ячейки.
	При нажатии на вторую кнопку происходит выход из режима программирования с соответсвующей индикацией перехода.
	При длительном нажатии (10 сек.) на вторую кнопку, происходит переход в режим стирания. Сначала включается 
	режим предупреждения на 5 сек. с мерцающей индикацией светодиодами, если за это время не будет нажата вторая кнопка 
	произойдет стирание всех записанных команд в ячейках радиоустройства. Процесс стирания отображается
	быстрым переключением светодиодов.
	
		Запись команд в память устройства проиходит следующим образом.
	После перехода в режим записи, выбирается номер требуемой ячейки или пишется в предложеный устройством 
	(оно предлагает последний автовыбранный для записи при предыдущем программировании адрес)
	Включается передатчик с сигналом записываемого кода, и как только он будет распознан, выключатся все светодиоды (Загорится светодиод на порту RB7 схемой не предусмотрен), после этого следует выключить передачу команды.
	После выключения сигнала передатчика светодиодами отобразится подтверждение записи в память и установится следующий адрес ячейки для записи. Режим записи остается активным. 
		Каждая запись занимает 4 байта первый байт - старший полубайт может быть использован пользователем по собственному усмотрению (корректируется с помощью сетевых команд записи в EEPROM). Младший полубайт содержит номер частоты модуляции. Всего 16 частот от 500 Гц до 2 кГц (см. таблицу) Он используется передатчиком для повторения не только кода но и частоты модуляции с точностью установки периода +-100мс. Три следующих байта содержат непосредственно код Радиокоманды.
21.01.2018
		Написан (но еще не отлажен) модуль адаптивного приема пакетов посылок радиосигналов по протоколу 1527 2262. 
	Модуль приема и проверки пакета, его записи в EEPROM и (или) сравнения полученного пакета с записанными в память.
		Адаптивный прием предполагает обнаружение модуляции и измерение ее частоты, Далее ведется прием пакета после появления преамбулы.
	Полученный пакет запоминается и продолжается прием следующего пакета. Второй полученный пакет сравнивается с первым.
	Если  пакеты не совпадают второй сохраняется на месте первого и принимается следующий пакет. Если совпадают два пакета выставляется флаг обнаруженного пакета зажигается светодиод на RB7. И далее пакет идет на обработку (либо запись в ЕЕПРОМ, либо поиск и сравнение полученного пакета с содержимым в памяти). Если пакет найден его номер отображается светодиодами. Если не найден светодиоды будут погашены.
	
	Написан алгоритм буферизации принятых пакетов, до обработки их Центральным устройством управления. 
	Так же создан буфер для передачи. Это позволяет передавать команды посылки пакетов (до 16 шт.) не особо беспокоясь 
	о скорости передачи пакетов устройством.
18.02.2018
		Отлажены все модули. Выпущена первая версия программы с полным функционалом.
	Номера, принятых и распознаных пакетов накапливаются 16-ти байтном буфере, до их считывания центральным устройством. При прочтении всех номеров из буфера будет читаться нуль.
		В обратную сторону буфер работает подобным образом. Передача каждого пакете ведется по 15 раз. соответственно если за время передачи пакета ЦУ запишет несколько номеров для передачи  передатчик их отработает так же до 16 шт.
	Передача пакета отображается Светодиодом RB7 (Планируется отображать номер передаваемого пакета)		
20.02.2018	
	Добавлен в парсер фильтр номера передваемого пакета - теперь устройство не отвечает на сетевую комаду передачи пакета с номером отличным от 01h до 1Fh 
	Так же добавлено отображение номера передаваемой команды светодиодами.
22.03.2018	
	Добавил анализ переполнения таймера 1 для инициализации перезапуска модуля приема. это понадобилось для варианта приемников в которых работает система шумоподавления. С такими приемниками после завершения приема пакета модуль приема не выходил из процедуры обработки пакета ожидая прихода хаотического шума на входе обозначающего конец передачи. в новой версии через 65 мс.  отсутствия сигнала модуль завершает обработку полученного пакета.
24.03.2018
	Отключен датчик снижения напряжения и внутренние подтягивающие резисторы, это позволило применять приемники с высоким выходным сопротивлением выхода "Дата" и запустить устройство с использованием стабилизатора напряжения питания 3В. 
30.03.2018	
	Почти незначительно улучшил прием. Точнее он стал лучше на гранично низкой частоте модуляции с периодом близким к 2 мс.
	### С кем связаться? ###

* Александр Вайдуров alex_aw@mail.ru
* Other community or team contact